org.optaplanner.core.config.heuristic.selector.move.composite

## Class CartesianProductMoveSelectorConfig

- java.lang.Object
- - org.optaplanner.core.config.AbstractConfig<C>
  - - org.optaplanner.core.config.heuristic.selector.SelectorConfig<C>
    - - org.optaplanner.core.config.heuristic.selector.move.MoveSelectorConfig<CartesianProductMoveSelectorConfig>
      - - org.optaplanner.core.config.heuristic.selector.move.composite.CartesianProductMoveSelectorConfig

-     public class CartesianProductMoveSelectorConfig
      extends MoveSelectorConfig<CartesianProductMoveSelectorConfig>

- - ### Field Summary

    - ### Fields inherited from class org.optaplanner.core.config.heuristic.selector.move.MoveSelectorConfig

      `cacheType, filterClassList, probabilityWeightFactoryClass, selectedCountLimit, selectionOrder, sorterClass, sorterComparatorClass, sorterOrder, sorterWeightFactoryClass`

  - ### Constructor Summary

    Constructors
    Constructor and Description
    `CartesianProductMoveSelectorConfig()`
    `CartesianProductMoveSelectorConfig(List<MoveSelectorConfig> moveSelectorConfigList)`

  - ### Method Summary

    All Methods Instance Methods Concrete Methods
    Modifier and Type | Method and Description
    --- | ---
    `MoveSelector` | `buildBaseMoveSelector(HeuristicConfigPolicy configPolicy, SelectionCacheType minimumCacheType, boolean randomSelection)`
    `void` | `extractLeafMoveSelectorConfigsIntoList(List<MoveSelectorConfig> leafMoveSelectorConfigList)` Gather a list of all descendant `MoveSelectorConfig`s except for `UnionMoveSelectorConfig` and `CartesianProductMoveSelectorConfig`.
    `Boolean` | `getIgnoreEmptyChildIterators()`
    `List<MoveSelectorConfig>` | `getMoveSelectorConfigList()`
    `void` | `inherit(CartesianProductMoveSelectorConfig inheritedConfig)` Inherits each property of the `inheritedConfig` unless that property (or a semantic alternative) is defined by this instance (which overwrites the inherited behaviour).
    `void` | `setIgnoreEmptyChildIterators(Boolean ignoreEmptyChildIterators)`
    `void` | `setMoveSelectorConfigList(List<MoveSelectorConfig> moveSelectorConfigList)`
    `String` | `toString()`

    - ### Methods inherited from class org.optaplanner.core.config.heuristic.selector.move.MoveSelectorConfig

      `buildMoveSelector, buildUnfoldedMoveSelectorConfig, determineBaseRandomSelection, getCacheType, getFilterClassList, getFixedProbabilityWeight, getProbabilityWeightFactoryClass, getSelectedCountLimit, getSelectionOrder, getSorterClass, getSorterComparatorClass, getSorterOrder, getSorterWeightFactoryClass, inheritFolded, isBaseInherentlyCached, setCacheType, setFilterClassList, setFixedProbabilityWeight, setProbabilityWeightFactoryClass, setSelectedCountLimit, setSelectionOrder, setSorterClass, setSorterComparatorClass, setSorterOrder, setSorterWeightFactoryClass, withCacheType, withFilterClassList, withFixedProbabilityWeight, withProbabilityWeightFactoryClass, withSelectedCountLimit, withSelectionOrder, withSorterClass, withSorterComparatorClass, withSorterOrder, withSorterWeightFactoryClass`

    - ### Methods inherited from class org.optaplanner.core.config.heuristic.selector.SelectorConfig

      `validateCacheTypeVersusSelectionOrder`

    - ### Methods inherited from class org.optaplanner.core.config.AbstractConfig

      `copyConfig, deduceEntityDescriptor, deduceVariableDescriptor, deduceVariableDescriptorList, newInstance`

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, wait, wait, wait`

- - ### Constructor Detail

    - #### CartesianProductMoveSelectorConfig

          public CartesianProductMoveSelectorConfig()

    - #### CartesianProductMoveSelectorConfig

          public CartesianProductMoveSelectorConfig(List<MoveSelectorConfig> moveSelectorConfigList)

  - ### Method Detail

    - #### getMoveSelectorConfigList

          public List<MoveSelectorConfig> getMoveSelectorConfigList()

    - #### setMoveSelectorConfigList

          public void setMoveSelectorConfigList(List<MoveSelectorConfig> moveSelectorConfigList)

    - #### getIgnoreEmptyChildIterators

          public Boolean getIgnoreEmptyChildIterators()

    - #### setIgnoreEmptyChildIterators

          public void setIgnoreEmptyChildIterators(Boolean ignoreEmptyChildIterators)

    - #### buildBaseMoveSelector

          public MoveSelector buildBaseMoveSelector(HeuristicConfigPolicy configPolicy,
                                                    SelectionCacheType minimumCacheType,
                                                    boolean randomSelection)

      Specified by:
        `buildBaseMoveSelector` in class `MoveSelectorConfig<CartesianProductMoveSelectorConfig>`
      Parameters:
        `configPolicy` - never null
        `minimumCacheType` - never null, If caching is used (different from `SelectionCacheType.JUST_IN_TIME`), then it should be at least this `SelectionCacheType` because an ancestor already uses such caching and less would be pointless.
        `randomSelection` - true is equivalent to `SelectionOrder.RANDOM`, false is equivalent to `SelectionOrder.ORIGINAL`
      Returns:
        never null

    - #### extractLeafMoveSelectorConfigsIntoList

          public void extractLeafMoveSelectorConfigsIntoList(List<MoveSelectorConfig> leafMoveSelectorConfigList)

      Description copied from class: `MoveSelectorConfig`
      Gather a list of all descendant `MoveSelectorConfig`s except for `UnionMoveSelectorConfig` and `CartesianProductMoveSelectorConfig`.
      Overrides:
        `extractLeafMoveSelectorConfigsIntoList` in class `MoveSelectorConfig<CartesianProductMoveSelectorConfig>`
      Parameters:
        `leafMoveSelectorConfigList` - not null

    - #### inherit

          public void inherit(CartesianProductMoveSelectorConfig inheritedConfig)

      Description copied from class: `AbstractConfig`
      Inherits each property of the `inheritedConfig` unless that property (or a semantic alternative) is defined by this instance (which overwrites the inherited behaviour).

      After the inheritance, if a property on this `AbstractConfig` composition is replaced, it should not affect the inherited composition instance.

      Overrides:
        `inherit` in class `MoveSelectorConfig<CartesianProductMoveSelectorConfig>`
      Parameters:
        `inheritedConfig` - never null

    - #### toString

          public String toString()

      Overrides:
        `toString` in class `AbstractConfig<CartesianProductMoveSelectorConfig>`

Copyright © 2006–2020 JBoss by Red Hat. All rights reserved.